routes/web.php
<?php

// Role permission ada di app/Http/helper.php
// file composer.json "files"
// middleware CheckPermission
// menambah role di helper.php
// make:model <directory>/modelname
Auth::routes();//default auth
Route::get('logout', '\App\Http\Controllers\Auth\LoginController@logout'); // kalau mau logout pakai route ini

Route::get('/', function () {
    return redirect()->route('login');
});


Route::group(['middleware' => ['auth', 'disablepreventback']], function(){
/*
  !!! semua wajib masuk sini supaya kalau mau akses harus login dulu !!!
  kalau page yang tidak butuh login di taruh di atas !!!
  kalau mau akses page untuk user tertentu pakai middleware checkPermission: namarole
*/
        // User Controllers
        Route::resource('user', 'UserController');
        //routing khusus wilayah
        Route::get('wilayah/kota','GmfControlller@getKota')->name('kota');
        Route::get('wilayah/kecamatan','GmfControlller@getKecamatan');
        Route::get('wilayah/kelurahan', 'GmfControlller@getKelurahan');

        Route::get('/home', 'HomeController@index')->name('home'); //sukses login arahnya ke sini
        Route::post('password/reset', 'ProfileController@resetpassword');
        Route::get('password/form', 'ProfileController@formreset');
        Route::post('profile/avatar', 'ProfileController@avatar')->name('avatar');
        Route::post('profile/{id}', 'ProfileController@biodata');
        //Mitra
        Route::resource('mitra', 'MitraController');

        //GMF
        Route::resource('gmf', 'GmfControlller');
        Route::get('gmf/kota', 'GmfControlller@getKota');
        Route::get('gmf/data', 'GmfControlller@getGmf');


        //siswa
        Route::resource('siswa', 'SiswaController');
        //dewasa
        Route::get('siswa_dewasa','SiswaController@index_dewasa');
        Route::post('/siswa_dewasa','SiswaController@store_dewasa');
        // Route::get('/siswa_dewasa/create','SiswaController@create_dewasa');
        Route::get('/siswa_dewasa/{siswa_dewasa}','SiswaController@show_dewasa');
        Route::delete('/siswa_dewasa/{siswa_dewasa}','SiswaController@destroy_dewasa');
        Route::put('/siswa_dewasa/{siswa_dewasa}','SiswaController@update_dewasa');
        Route::get('/siswa_dewasa/{siswa_dewasa}/edit','SiswaController@edit_dewasa');

        //siswa-end

        Route::group(['middleware' => 'check-permission:admin'], function()
        {
            Route::resource('admin', 'AdminController');
        });
        Route::resource('profile', 'ProfileController');

Route::get('admin',['middleware'=>'check-permission:gmf','uses'=>'HomeController@index']);
//Route::resource('mitra', 'MitraController')->middleware('check-permission:cabang'); // contoh penggunaan middleware
});

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password','role','username'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\User;
use DB;
use Illuminate\Support\Facades\Hash;
class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $data = DB::table('users')
        ->join('tb_role','tb_role.id_role','=','users.role')
        ->get();
        $role = DB::table('tb_role')->get();

        return view('user.user-kelola',['array' => $data, 'role' => $role]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $user = new User;
        $user->name = $request->name;
        $user->nomor_anggota = $request->id_gmf;
        $user->role = $request->role;
        $user->username = $request->username;
        $user->email = $request->email;
        $user->password = Hash::make($request->password);
        $user->save();
        return redirect()->route('user.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/user/user-kelola.blade.php
@extends('layouts.app')
@section('content')
<div class="row">
    <div class="col-md-12">
        <div class="card">
            <div class="card-header">
              <h5>Kelola User</h5>
              <button class="btn btn-primary btn-round waves-effect waves-light add" style="position:absolute;right:10px;top:15px">Tambah</button>
            </div>
            <div class="card-block">
              <div class="table-responsive">
                <table id="tbUser" class="table table-hover">
                  <thead>
                    <tr>
                      <th>No</th>
                      <th>Nama</th>
                      <th>Username</th>
                      <th>Email</th>
                      <th>Role</th>
                      <th>Id GMF</th>
                      <th>Opsi</th>
                    </tr>
                  </thead>
                  <tbody>
                    @php $no = 1; @endphp
                    @forelse ($array as $data)
                      <tr>
                        <td>{{ $no++ }}</td>
                        <td>{{ $data->name }}</td>
                        <td>{{ $data->username }}</td>
                        <td>{{ $data->email }}</td>
                        <td>{{ $data->nama_role }}</td>
                        <td>{{ $data->id_mitra }}</td>
                        <td>
                          <button class="btn waves-effect waves-light btn-warning edit" value="{{ $data->id }}"><i class="fa fa-pencil"></i>Edit</button>
                          <form action="{{ route('user.destroy',$data->id) }}" method="post" style="display:inline-block">
                            @csrf @method('DELETE')
                            <button type="submit" name="button" class="btn waves-effect waves-light btn-danger">Delete</button>
                          </form>
                        </td>
                      </tr>
                    @empty
                      <p>Data Masih Kosong</p>
                    @endforelse
                  </tbody>
                </table>
              </div>
            </div>
        </div>
<!--Modal: ADD-->
<div class="modal fade" id="modalPush" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
  aria-hidden="true">
  <div class="modal-dialog modal-notify modal-info" role="document">
    <!--Content-->
    <div class="modal-content text-center">
      <!--Header-->
      <div class="modal-header d-flex justify-content-center">
        <h5>Tambah User</h5>
      </div>

      <!--Body-->
      <div class="modal-body">
      <form class="" action="{{ route('user.store') }}" method="post">
        @csrf
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Nama Terang</label>
          <div class="col-sm-6">
              <input type="text" name="name" class="form-control">
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Id GMF</label>
          <div class="col-sm-6">
              <input type="text" name="id_gmf" class="form-control" required>
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Username</label>
          <div class="col-sm-6">
              <input type="text" name="username" class="form-control" required>
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Role</label>
          <div class="col-sm-4">
              <select class="custom-select" name="role">
                @foreach ($role as $roles)
                  <option value="{{ $roles->id_role }}">{{ $roles->nama_role }}</option>
                @endforeach
              </select>
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Email</label>
          <div class="col-sm-6">
              <input type="email" name="email" class="form-control">
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Password</label>
          <div class="col-sm-6">
              <input type="password" name="password" class="form-control">
          </div>
        </div>
        <button type="submit" name="button" class="btn btn-info">Create</button>
        <button type="button" name="button" data-dismiss="modal" class="btn btn-outline-info waves-effect">Close</button>
      </form>
      </div>

      <!--Footer-->
      <div class="modal-footer flex-center">
        {{-- <a href="https://mdbootstrap.com/products/jquery-ui-kit/" class="btn btn-info">Yes</a> --}}
        {{-- <a type="button" class="btn btn-outline-info waves-effect" data-dismiss="modal">close</a> --}}
      </div>
    </div>
    <!--/.Content-->
  </div>
</div>
<!--Modal: modalAdd-->
<!--Modal: modalEdit-->
<div class="modal fade" id="modalEdit" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
  aria-hidden="true">
  <div class="modal-dialog modal-notify modal-info" role="document">
    <!--Content-->
    <div class="modal-content text-center">
      <!--Header-->
      <div class="modal-header d-flex justify-content-center">
        <h5>Tambah User</h5>
      </div>

      <!--Body-->
      <div class="modal-body">
      <form id="formEdit" method="post">
        @method('PUT')
        @csrf
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Nama Terang</label>
          <div class="col-sm-6">
              <input id="nama" type="text" name="name" class="form-control">
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Id GMF</label>
          <div class="col-sm-6">
              <input id="idGmf" type="text" name="id_gmf" class="form-control">
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Username</label>
          <div class="col-sm-6">
              <input id="username" type="text" name="username" class="form-control">
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Role</label>
          <div class="col-sm-4">
              <select class="custom-select" name="role">
                @foreach ($role as $roles)
                  <option value="{{ $roles->id_role }}">{{ $roles->nama_role }}</option>
                @endforeach
              </select>
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Email</label>
          <div class="col-sm-6">
              <input id="email" type="email" name="email" class="form-control">
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label">Password</label>
          <div class="col-sm-6">
              <input type="password" name="password" class="form-control">
          </div>
        </div>
        <button type="submit" name="button" class="btn btn-primary">Edit</button>
        <button type="button" name="button" data-dismiss="modal" class="btn btn-outline-info waves-effect">Close</button>
      </form>
      </div>

      <!--Footer-->
      <div class="modal-footer flex-center">
        {{-- <a href="https://mdbootstrap.com/products/jquery-ui-kit/" class="btn btn-info">Yes</a> --}}
        {{-- <a type="button" class="btn btn-outline-info waves-effect" data-dismiss="modal">close</a> --}}
      </div>
    </div>
    <!--/.Content-->
  </div>
</div>
<!--Modal: modalEdit-->
    </div>
</div>
@endsection

@section('javascript')
<script>
$(document).ready(function() {
  $('.add').click(function(event) {
    $('#modalPush').modal('show');
  });
$('#tbUser').on('click', '.edit', function(event) {
  event.preventDefault();
  var id = $(this).val();
  var nama = $(this).closest('tr').find('td:eq(1)').text();
  var username = $(this).closest('tr').find('td:eq(2)').text();
  var email = $(this).closest('tr').find('td:eq(3)').text();
  var idgmf = $(this).closest('tr').find('td:eq(5)').text();
  $('#modalEdit').modal('show');
  $('#nama').val(nama);
  $('#username').val(username);
  $('#idGmf').val(idgmf);
  $('#email').val(email);
  $('#formEdit').attr('action','{{ url('user') }}'+'/'+id);

});

});
</script>
@endsection